options nocenter validvarname=any;

*---Read in space-delimited ascii file;

* Karima note: rename input vars;
data rni;
infile 'c:/workshops/summer_2009/recipiency/lintyear_intdate9394.dat' lrecl=97 missover DSD DLM=' ' print;
input
  caseid     /* R0000100  */
  race       /* R0214700  */
  sex        /* R0214800  */
  rni_1980   /* R0406310  */ 
  rni_1981   /* R0618810  */ 
  rni_1982   /* R0898510  */ 
  rni_1983   /* R1144710  */ 
  rni_1984   /* R1519910  */ 
  rni_1985   /* R1890300  */ 
  rni_1986   /* R2257400  */ 
  rni_1987   /* R2444600  */ 
  rni_1988   /* R2870100  */ 
  rni_1989   /* R3073900  */ 
  rni_1990   /* R3400500  */ 
  rni_1991   /* R3655900  */ 
  rni_1992   /* R4006400  */ 
  intmo93    /* R4100200  */
  intday93   /* R4100201  */
  intyr93    /* R4100202  */
  rni_1993   /* R4417500  */
  intday94   /* R4500200  */ 
  intmo94    /* R4500201  */
  intyr94    /* R4500202  */
  rni_1994   /* R5080500  */
  rni_1996   /* R5165800  */
  rni_1998   /* R6478500  */
  rni_2000   /* R7006300  */
  rni_2002   /* R7703500  */
  rni_2004   /* R8495900  */
  rni_2006   /* T0987500  */
;
/* Karima note: comment out array with default recoding of missing values
array nvarlist _numeric_;


*---Recode missing values to SAS custom system missing. See SAS
      documentation for use of MISSING option in procedures, e.g. PROC FREQ;

do over nvarlist;
  if nvarlist = -1 then nvarlist = .R;  -- Refused --
  if nvarlist = -2 then nvarlist = .D;  -- Dont know --
  if nvarlist = -3 then nvarlist = .I;  -- Invalid missing --
  if nvarlist = -4 then nvarlist = .V;  -- Valid missing --
  if nvarlist = -5 then nvarlist = .N;  -- Non-interview --
end;
*/
  label caseid     /* R0000100 */  = "ID# (1-12686) 79";
  label race       /* R0214700 */  = "RACL/ETHNIC COHORT /SCRNR 79";
  label sex        /* R0214800 */  = "SEX OF R 79";
  label rni_1980   /* R0406310 */  = "REASON FOR NONINT 80";
  label rni_1981   /* R0618810 */  = "REASON FOR NONINT 81";
  label rni_1982   /* R0898510 */  = "REASON FOR NONINT 82";
  label rni_1983   /* R1144710 */  = "REASON FOR NONINT 83";
  label rni_1984   /* R1519910 */  = "REASON FOR NONINT 84";
  label rni_1985   /* R1890300 */  = "REASON FOR NONINT 85";
  label rni_1986   /* R2257400 */  = "REASON FOR NONINT 86";
  label rni_1987   /* R2444600 */  = "REASON FOR NONINT 87";
  label rni_1988   /* R2870100 */  = "REASON FOR NONINT 88";
  label rni_1989   /* R3073900 */  = "REASON FOR NONINT 89";
  label rni_1990   /* R3400500 */  = "REASON FOR NONINT 90";
  label rni_1991   /* R3655900 */  = "REASON FOR NONINT 91";
  label rni_1992   /* R4006400 */  = "REASON FOR NONINT 92";
  label intmo93    /* R4100200 */  = "DATE OF INTERVIEW 93:MO";
  label intday93   /* R4100201 */  = "DATE OF INTERVIEW 93:DY";
  label intyr93    /* R4100202 */  = "DATE OF INTERVIEW 93:YR";
  label rni_1993   /* R4417500 */  = "REASONS FOR NON-INT 93";
  label intday94   /* R4500200 */  = "DATE OF INTERVIEW 94";
  label intmo94    /* R4500201 */  = "DATE OF INTERVIEW 94";
  label intyr94    /* R4500202 */  = "DATE OF INTERVIEW 94";
  label rni_1994   /* R5080500 */  = "REASONS FOR NON-INT 94";
  label rni_1996   /* R5165800 */  = "REASONS FOR NON-INT 96";
  label rni_1998   /* R6478500 */  = "REASONS FOR NON-INT 1998";
  label rni_2000   /* R7006300 */  = "REASONS FOR NON-INT 2000";
  label rni_2002   /* R7703500 */  = "REASONS FOR NON-INT 2002";
  label rni_2004   /* R8495900 */  = "REASONS FOR NON-INT 2004";
  label rni_2006   /* T0987500 */  = "REASONS FOR NON-INT 2006";

/*---------------------------------------------------------------------*
 *  Crosswalk for Reference number & Question name                     *
 *---------------------------------------------------------------------*
 * Uncomment and edit this RENAME statement to rename variables
 * for ease of use.  You may need to use  name literal strings
 * e.g.  'variable-name'n   to create valid SAS variable names, or 
 * alter variables similarly named across years.
 * This command does not guarentee uniqueness

 * See SAS documentation for use of name literals and use of the
 * VALIDVARNAME=ANY option.     
 *---------------------------------------------------------------------*/
  /* *start* */
* Karima note: rename statement could be used instead of renaming in input statement;
* RENAME
  R0000100 = caseid     /* 'CASEID_1979'n    */ 
  R0214700 = race       /* '*Created_1979'n  */ 
  R0214800 = sex        /* '*Created_1979'n  */ 
  R0406310 = rni_1980   /* '*Created_1980'n  */ 
  R0618810 = rni_1981   /* '*Created_1981'n  */ 
  R0898510 = rni_1982   /* '*Created_1982'n  */ 
  R1144710 = rni_1983   /* '*Created_1983'n  */ 
  R1519910 = rni_1984   /* '*Created_1984'n  */ 
  R1890300 = rni_1985   /* '*Created_1985'n  */ 
  R2257400 = rni_1986   /* '*Created_1986'n  */ 
  R2444600 = rni_1987   /* '*Created_1987'n  */ 
  R2870100 = rni_1988   /* '*Created_1988'n  */ 
  R3073900 = rni_1989   /* '*Created_1989'n  */ 
  R3400500 = rni_1990   /* '*Created_1990'n  */ 
  R3655900 = rni_1991   /* '*Created_1991'n  */ 
  R4006400 = rni_1992   /* '*Created_1992'n  */ 
  R4100200 = intmo93    /* 'Q-1C_1993'n      */ 
  R4100201 = intday93   /* 'Q-1C_1993'n      */ 
  R4100202 = intyr93    /* 'Q-1C_1993'n      */ 
  R4417500 = rni_1993   /* 'RNI_1993'n       */ 
  R4500200 = intday94   /* 'Q-1C~D_1994'n    */ 
  R4500201 = intmo94    /* 'Q-1C~M_1994'n    */ 
  R4500202 = intyr94    /* 'Q-1C~Y_1994'n    */ 
  R5080500 = rni_1994   /* 'RNI_1994'n       */ 
  R5165800 = rni_1996   /* 'RNI_1996'n       */ 
  R6478500 = rni_1998   /* 'RNI_1998'n       */ 
  R7006300 = rni_2000   /* 'RNI_2000'n       */ 
  R7703500 = rni_2002   /* 'RNI_2002'n       */ 
  R8495900 = rni_2004   /* 'RNI_2004'n       */ 
  T0987500 = rni_2006   /* 'RNI_2006'n       */ 
;
  /* *finish* */

run;

proc means data=rni n mean min max;
run;


/*---------------------------------------------------------------------*
 *  FORMATTED TABULATIONS                                              *
 *---------------------------------------------------------------------*
 * You can uncomment and edit the PROC FORMAT and PROC FREQ statements 
 * provided below to obtain formatted tabulations. The tabulations 
 * should reflect codebook values.
 * 
 * Please edit the formats below reflect any renaming of the variables
 * you may have done in the first data step. 
 *---------------------------------------------------------------------*/

/*
proc format; 
*/

/* 
 *--- Tabulations using reference number variables;
proc freq data=rni;
tables _ALL_ /MISSING;
run;
*/

/*
*--- Tabulations using default named variables;
proc freq data=rni;
tables _ALL_ /MISSING;
run;
*/

proc freq; tables intmo93 intday93 intyr93 intmo94 intday94 intyr94;
run;