/* File to run a regression using  NLSY79 data */

options nocenter validvarname=any;

data new_data;

/* Change the below line to match where the data are on your computer */
infile 'C:\Documents and Settings\zagorsky\Desktop\NLS_Docs\SummerConference\2009_RandysFiles\Weighting.dat' lrecl=44 missover DSD DLM=' ' print;
input
  R0000100
  R0214700
  R0214800
  T0987300
  T0987800
  T0988200
  T0988300
  T0988400
  T0988800
  T0989000
;
array nvarlist _numeric_;


*---Recode missing values to SAS custom system missing. See SAS
      documentation for use of MISSING option in procedures, e.g. PROC FREQ;

do over nvarlist;
  if nvarlist = -1 then nvarlist = .R;  /* Refused */
  if nvarlist = -2 then nvarlist = .D;  /* Dont know */
  if nvarlist = -3 then nvarlist = .I;  /* Invalid missing */
  if nvarlist = -4 then nvarlist = .V;  /* Valid missing */
  if nvarlist = -5 then nvarlist = .N;  /* Non-interview */
end;

  label R0000100 = "ID# (1-12686) 79";
  label R0214700 = "RACL/ETHNIC COHORT /SCRNR 79";
  label R0214800 = "SEX OF R 79";
  label T0987300 = "SAMPLING WEIGHT 2006";
  label T0987800 = "TOTAL NET FAMILY INCOME 2006";
  label T0988200 = "EMP STATUS RECODE (COLLAPSED) 2006";
  label T0988300 = "REGION OF RESIDENCE 2006";
  label T0988400 = "MARITAL STATUS (COLLAPSED) 2006";
  label T0988800 = "HIGHEST GRADE COMPLTD (REV) 2006";
  label T0989000 = "AGE AT INTERVIEW DATE 2006";

TRUE  = 1;
FALSE = 0;

if (R0214700 = 1)  /* RACL/ETHNIC COHORT /SCRNR 79 */
	then HISPANIC = TRUE;
	else HISPANIC = FALSE;
if (R0214700 = 2)  /* RACL/ETHNIC COHORT /SCRNR 79 */
	then BLACK = TRUE;
	else BLACK = FALSE;

if (R0214800 = 2) /* SEX OF R 79 */
	then FEMALE = TRUE;
	else FEMALE = FALSE;

TNFI = T0987800;  /* TOTAL NET FAMILY INCOME 2006 */

if (T0988200 = 1) /* EMP STATUS RECODE (COLLAPSED) 2006 */
	then EMPLOYED = TRUE;
	else EMPLOYED = FALSE;

if (T0988300 = 3)  /* REGION OF RESIDENCE 2006 */
	then LiveInSouth = TRUE;
	else LiveInSouth = FALSE;

if (T0988400 = 2)  /* MARITAL STATUS (COLLAPSED) 2006 */
	then Married = TRUE;
	else Married = FALSE;

HGC = T0988800;  /* HIGHEST GRADE COMPLTD (REV) 2006 */
AGE = T0989000;  /* AGE AT INTERVIEW DATE 2006 */

proc reg;
model TNFI = AGE HGC Married LiveInSouth Employed Female Black Hispanic;
run;
